using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;

/// <summary>
/// Summary description for Reuse
/// </summary>
public class Reuse
{
    public SqlConnection con;
    public SqlCommand cmd;
    SqlDataReader dr;
    SqlDataAdapter da;
    DataSet ds;
    public string ConString;
    string sqlcmd;
	public Reuse()
	{
        ConString = System.Configuration.ConfigurationManager.ConnectionStrings["ConnString"].ConnectionString;
        con = new SqlConnection(ConString); 
		//
		// TODO: Add constructor logic here
		//
	}
    public void Insert(string sqlQuery)
    {
        con.Open();
        cmd = new SqlCommand(sqlQuery, con);
        cmd.ExecuteNonQuery();
        con.Close();
    }
    public void Update(string sqlQuery)
    {
        con.Open();
        cmd = new SqlCommand(sqlQuery, con);
        cmd.ExecuteNonQuery();
        con.Close();
    }
    public void Delete(string sqlQuery)
    {
        con.Open();
        cmd = new SqlCommand(sqlQuery, con);
        cmd.ExecuteNonQuery();
        con.Close();
    }
    public DataSet DataAdapter(string sqlQuery)
    {
        da = new SqlDataAdapter(sqlQuery, con);
        ds = new DataSet();
        da.Fill(ds,"Table");
        return ds;
    }
    public string[] DataReader(string sqlQuery,int NoOfFields)
    {
        string[] myStringArray = new string[NoOfFields]; 
        con.Open();
        cmd = new SqlCommand(sqlQuery, con);
        dr = cmd.ExecuteReader();        
        while (dr.Read())
        {          
            for(int i = 0; i < NoOfFields;i++)
                myStringArray[i] = dr[i].ToString();               
            
        }
        con.Close();
        return myStringArray;
    }
    public void StoreBackup()
    {
        try
        {
            DateTime dt = DateTime.Now;

            string fn = "ERP" + dt.ToString("dd-MM-yy hh-mm tt");
            string appPath = HttpContext.Current.Request.ApplicationPath;
            string physicalPath = HttpContext.Current.Request.MapPath(appPath);
            string newPath = System.IO.Path.Combine(physicalPath + "\\DatabaseBackup\\Backup", fn);
            System.IO.Directory.CreateDirectory(newPath);
            con = new SqlConnection(ConString);
            con.Open();

            sqlcmd = "backup database ERP to disk='" + newPath + "\\ERP'";
            //objReuse.InsertUpdateDelete(sqlcmd);
            cmd = new SqlCommand(sqlcmd, con);
            cmd.ExecuteNonQuery();

            sqlcmd = "select * from BackupDetails";
            cmd = new SqlCommand(sqlcmd, con);
            dr = cmd.ExecuteReader();
            if (dr.Read())
            {
                dr.Close();
                con.Close();
                sqlcmd = "update BackupDetails set LastDate='" + dt + "'";
                Update(sqlcmd);
            }
            else
            {
                dr.Close();
                con.Close();
                sqlcmd = "insert into BackupDetails values('" + dt + "')";
                Insert(sqlcmd);
            }            
            //Response.Write("<script>alert ('Backuped Successfully ')</script>");
        }
        catch (Exception e)
        {
            //Response.Write(e);
        }

    }
    public void CheckLastBackup()
    {
        con.Open();
        string sqlcmd = "select LastDate from BackupDetails";
        cmd = new SqlCommand(sqlcmd, con);
        dr = cmd.ExecuteReader();
        if (dr.Read())
        {
            DateTime startTime = DateTime.Now;
            DateTime endTime = Convert.ToDateTime(dr["LastDate"].ToString());
            TimeSpan span = endTime.Subtract(startTime);
            double Seconds,Minutes,Hours,Days;
            Seconds = span.Seconds;
            Minutes= span.TotalMinutes;
            Hours = span.TotalHours;
            Days = span.TotalDays;
            if (Hours < -47)
            {                
                StoreBackup();                
            }
        }
        con.Close();
    }
    
}
